=== samples/GetInfo/Makefile ===
OPENCL_DEPTH = ../../..

include $(OPENCL_DEPTH)/runtimenew/runtimedefs

SUBDIRS = build
      
include $(OPENCL_DEPTH)/runtimenew/runtimerules
