=== samples/GetInfo/build/Makefile ===
OPENCL_DEPTH = ../../../..

include $(OPENCL_DEPTH)/hsadefs

BUILD_SUBDIRS = $(DEFAULT_TARGETS)
BUILD_MAKEFILE = Makefile.get_info

include $(OPENCL_DEPTH)/hsarules
