=== debian/changelog ===
rocr-runtime (6.4.3+dfsg-1~exp2) experimental; urgency=medium

  * Add d/p/0009-fix-missing-symbols.patch to fix the missing
    symbols hsaKmtRegisterGraphicsHandleToNodesExt and
    hsaKmtCreateQueueExt in libhsakmt1.
  * Add d/p/0010-fix-missing-stdint.h.patch to fix build with
    GCC 15 (Closes: #1097800)

 -- Cordell Bloor <cgmb@debian.org>  Fri, 12 Sep 2025 20:43:52 -0600

rocr-runtime (6.4.3+dfsg-1~exp1) experimental; urgency=medium

  [ Cordell Bloor ]
  * New upstream version 6.4.3+dfsg
    * src:rocr-runtime has subsumed src:roct-thunk-interface
    * libhsakmt1 and libhsakmt-dev are now produced by
      src:rocr-runtime package build
    * Updated symbols, refreshed patches for new upstream version,
      and copied applicable patches from src:roct-thunk-interface
  * Update Build-Depends from clang-17 to clang-20
  * Add libnuma-dev to Build-Depends
  * Update standards version to 4.7.2
    * No changes required

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Cordell Bloor <cgmb@debian.org>  Wed, 27 Aug 2025 17:06:07 -0600
