=== debian/control ===
Source: rocr-runtime
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Maxime Chambonnet <maxzor@maxzor.eu>,
           Étienne Mollier <emollier@debian.org>,
           Cordell Bloor <cgmb@debian.org>,
           Xuanteng Huang <xuanteng.huang@outlook.com>,
           Christian Kastner <ckk@debian.org>,
           Mario Limonciello <superm1@gmail.com>,
Section: video
Priority: optional
Build-Depends: architecture-is-64-bit,
               clang-20,
               clang-tools-20,
               cmake,
               debhelper-compat (= 13),
               libclang-20-dev,
               libdrm-dev,
               libelf-dev,
               libmlir-20-dev,
               libnuma-dev,
               lld-20,
               llvm-20-dev,
               mlir-20-tools,
               pkgconf,
               rocm-device-libs-20,
               xxd,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/rocm-team/rocr-runtime
Vcs-Git: https://salsa.debian.org/rocm-team/rocr-runtime.git
Homepage: https://github.com/ROCm/ROCR-Runtime/
Rules-Requires-Root: no

Package: libhsa-runtime64-1
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.

Package: libhsa-runtime-dev
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Section: libdevel
Depends: libhsa-runtime64-1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm - development files
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.
 .
 This package contains the development headers.

Package: libhsakmt1
Section: libs
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Thunk library for AMD KFD (shlib)
 This package includes the user-mode API interfaces used to interact with the
 ROCk driver.
 .
 This package contains the shared object.

Package: libhsakmt-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libhsakmt1 (= ${binary:Version}), ${misc:Depends},
Multi-Arch: same
Description: Thunk library for AMD KFD (dev)
 This package includes the user-mode API interfaces used to interact with the
 ROCk driver.
 .
 This package contains the development files.
